﻿
// testDlg.cpp: 구현 파일
//

#include "pch.h"
#include "framework.h"
#include "test.h"
#include "testDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 응용 프로그램 정보에 사용되는 CAboutDlg 대화 상자입니다.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 대화 상자 데이터입니다.
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

// 구현입니다.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CtestDlg 대화 상자



CtestDlg::CtestDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_TEST_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CtestDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CtestDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CtestDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CtestDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CtestDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CtestDlg 메시지 처리기

BOOL CtestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 이 대화 상자의 아이콘을 설정합니다.  응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.

	// TODO: 여기에 추가 초기화 작업을 추가합니다.

	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

void CtestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다.  문서/뷰 모델을 사용하는 MFC 애플리케이션의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CtestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트입니다.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CtestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/*
C# MultiMap Class(Dictionary of Lists) - Dot Net Perls
http ://www.dotnetperls.com/multimap

Thinking Different::CAtlMap 정리 및 예제
http ://copynull.tistory.com/102
*/


#include <atlcoll.h>

void CtestDlg::OnBnClickedButton1()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	CAtlMap <int, int> amap;

	amap[10] = 10;
	amap[10] = 20;
	amap[30] = 30;
	amap[40] = 40;

	POSITION pos = amap.GetStartPosition();
	while (1)
	{
		if (pos == NULL)
			break;

		amap.GetKeyAt(pos);
		int t = amap.GetValueAt(pos);
		TRACE("[--------] %d \n", t);
		amap.GetNextKey(pos);
//		amap.GetNextValue(pos);

//		CAtlMap <int, int>::CPair* pair = amap.GetNext(pos);
//		CAtlMap <int, int>::CPair* pair = amap.GetAt(pos);
		
	}
	bool b = amap.RemoveKey(1);
//	amap.RemoveAtPos(pos);
	amap.RemoveAll();
	DWORD size = amap.GetCount();
	b = amap.IsEmpty();
	amap.InitHashTable(2500);
	amap.DisableAutoRehash();
	amap.EnableAutoRehash();
	amap.Rehash();

}



void CtestDlg::OnBnClickedButton2()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	FILE* fpr;
	fpr = fopen("test.bmp", "rb");
	FILE* fp;
	fp = fopen("test.txt", "wt");
	FILE* fp2;
	fp2 = fopen("test2.txt", "wb");
	FILE* fp3;
	fp3 = fopen("test3.txt", "wb");




	srand(time(NULL));
	char buf[100] = { "22" };
	int cnt = 0;
	while (1)
	{
		char data;
		int e;
		int i;
		for (i = 0; i < 6; i++)
		{
			e = fread(&data, 1, 1, fpr);
			buf[i] = data;
		}
		if (e == 0) break;
		int len = strlen(buf);

		long l = atol(buf);
		if (l == 0)
		{
			data = l;
			fwrite(&data, 1, 1, fp3);
			continue;
		}
		else
		{
			data = ' ';
			fwrite(&data, 1, 1, fp3);
		}
		int r = pow(rand() % 8 * rand() % 8 * rand() % 8, 2) + rand() % 8;
		if (r < l)	l = l - r;
		//	l = l + rand()%8+rand()%8;
		//	printf("%d\n", l);

		fseek(fp, 0, SEEK_CUR);
		fseek(fp, 0, SEEK_SET);
		fseek(fp, l, SEEK_SET);
		fseek(fp, l, SEEK_CUR);

		fread(&data, 1, 1, fp);
		if (data >= '0')
		{

			fseek(fp, 0, SEEK_CUR);
			fseek(fp, 0, SEEK_SET);
			fseek(fp, l, SEEK_SET);
			fseek(fp, l, SEEK_CUR);
			//		printf("%c", data);
			for (i = 0; i < 6; i++)
			{
				data = buf[i];
				fwrite(&data, 1, 1, fp2);
			}
		}
		else
		{

			fseek(fp, 0, SEEK_CUR);
			fseek(fp, 0, SEEK_SET);
			fseek(fp, l, SEEK_SET);
			fseek(fp, l, SEEK_CUR);
			data = cnt + '0';
			fwrite(&data, 1, 1, fp);
			cnt++;
			if (cnt > 255)
			{
				//			printf("cnt : %d\n", cnt);
			}

			data = ' ';
			fwrite(&data, 1, 1, fp2);
		}
	}

	printf("\n");
	fclose(fpr);
	fclose(fp);
	fclose(fp2);
	fclose(fp3);

	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test.7z test.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test2.7z test2.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test3.7z test3.txt");

}






//
int data;
unsigned char rand_data[10];
unsigned char buf;


// 8개의 랜덤값을 중복 안되도록 모아서 압축에 사용한다.

int fn_rand_length()

{

	//

	int count1 = 0;

	int count2 = 0;

	int count3 = 0;

	int count4 = 0;

	int count5 = 0;

	int count6 = 0;

	int count7 = 0;

	int count8 = 0;



	//

	unsigned char vv[10];

	char order[10];



	//

	count1 = 0;

	count2 = 0;

	count3 = 0;

	count4 = 0;

	count5 = 0;

	count6 = 0;

	count7 = 0;

	count8 = 0;



	//

	memset(&order[0], 0x00, 10);

	memset(&vv[0], 0x00, 10);

	memset(&rand_data[0], 0x00, 10);



	//

	int i = 0;

	i = 0;



	//

	while (1)

	{

		data = rand() % 8;





		if (data == 0 && count1 == 0)

		{

			if ((buf >> 7) & 0x1 == 1)

			{

				data = '7';

				vv[i] = data;

			}

			else

			{

				data = '7';

				vv[i] = data;

			}



			data = '0';	count1++;

			order[i] = '0'; i++;

			//printf("[     ] 111111111111 \n  ");

		}

		else if (data == 1 && count2 == 0)

		{



			if ((buf >> 6) & 0x1 == 1)

			{

				data = '6';

				vv[i] = data;

			}

			else

			{

				data = '6';

				vv[i] = data;

			}



			data = '1';	count2++;

			order[i] = '1'; i++;

			//printf("[     ] 2222222222222 \n  ");

		}



		else if (data == 2 && count3 == 0)

		{



			if ((buf >> 5) & 0x1 == 1)

			{

				data = '5';

				vv[i] = data;

			}

			else

			{

				data = '5';

				vv[i] = data;

			}



			data = '2';	count3++;

			order[i] = '2'; i++;

			//printf("[     ] 333333333333333 \n  ");

		}

		else if (data == 3 && count4 == 0)

		{



			if ((buf >> 4) & 0x1 == 1)

			{

				data = '4';

				vv[i] = data;

			}

			else

			{

				data = '4';

				vv[i] = data;

			}



			data = '3';	count4++;

			order[i] = '3'; i++;

			//printf("[     ] 44444444444 \n  ");

		}

		else if (data == 4 && count5 == 0)

		{



			if ((buf >> 3) & 0x1 == 1)

			{

				data = '3';

				vv[i] = data;

			}

			else

			{

				data = '3';

				vv[i] = data;

			}



			data = '4';	count5++;

			order[i] = '4'; i++;

			//printf("[     ] 5555555555 \n  ");

		}

		else if (data == 5 && count6 == 0)

		{



			if ((buf >> 2) & 0x1 == 1)

			{

				data = '2';

				vv[i] = data;

			}

			else

			{

				data = '2';

				vv[i] = data;

			}



			data = '5';	count6++;

			order[i] = '5'; i++;

			//printf("[     ] 6666666666 \n  ");

		}

		else if (data == 6 && count7 == 0)

		{



			if ((buf >> 1) & 0x1 == 1)

			{

				data = '1';

				vv[i] = data;

			}

			else

			{

				data = '1';

				vv[i] = data;

			}



			data = '6';	count7++;

			order[i] = '6'; i++;

			//printf("[     ]  777777777777777 \n ");

		}

		else if (data == 7 && count8 == 0)

		{



			if ((buf >> 0) & 0x1 == 1)

			{

				data = '0';

				vv[i] = data;

			}

			else

			{

				data = '0';

				vv[i] = data;

			}



			data = '7';	count8++;

			order[i] = '7'; i++;

			//printf("[     ]  8888888888 \n ");

		}





		if (count1 > 0 && count2 > 0 && count3 > 0 && count4 > 0 && count5 > 0 && count6 > 0 && count7 > 0 && count8 > 0)

		{

			count1 = 0;

			count2 = 0;

			count3 = 0;

			count4 = 0;

			count5 = 0;

			count6 = 0;

			count7 = 0;

			count8 = 0;

			//printf("[     ]  xxxxxxxxxxxxxxxxxx \n ");







/*

		//-----------------------------------------------------------------

		//실패

		//압축효율 5%  6MB -> 54MB -> 2.7MB

		//-----------------------------------------------------------------

		for(i=0; i<8; i++) //테스트 코드

		{

			fwrite(&order[i], 1, 1, fp); //원본.



			//같은 번호 순서

			if(order[i]-48 == i )

			{

				char order2 = order[0]-48;



				if( (buf >> i) & 0x1 )

				{

					order[i] = order[i] + order[i]-48;

					fwrite(&order[i], 1, 1, fp); //추가된 비트값

				}

				else

				{

					order[i] = order[i] - order2;

					fwrite(&order[i], 1, 1, fp); //제거된 비트값

				}



			}

		}

*/





			break;

		}



	}

	//printf("[     ]  eeeeeeeeeeee \n ");



	//갯수

	strcpy((char*)& rand_data[0], (char*)vv);

	int rcount = strlen((char*)vv);

	return rcount;

}

void CtestDlg::OnBnClickedButton3()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	FILE* fpr;
	fpr = fopen("test.bmp", "rb");
	FILE* fp;
	fp = fopen("test.txt", "wt");
	FILE* fp2;
	fp2 = fopen("test2.txt", "wb");
	FILE* fp3;
	fp3 = fopen("test3.txt", "wb");

	char* mem;
	mem = (char*)malloc(10000000);
	memset(mem, 0x00, 10000000);
	
	srand(time(NULL));
	char buf[100] = { "22" };
	long cnt = 0;
	while (1)
	{
		unsigned char data;
		int e;
		int i;
		for (i = 0; i < 6; i++)
		{
			e = fread(&data, 1, 1, fpr);
			buf[i] = data;
		}
		if (e == 0) break;
		int len = strlen(buf);

		long l = atol(buf);

		if (l == 0)
		{
			data = l;
//			fwrite(&data, 1, 1, fp3);
			continue;
		}
		else
		{
			data = ' ';
//			fwrite(&data, 1, 1, fp3);
		}


//		long r = pow(rand() % 8 * rand() % 8 * rand() % 8, 2) + rand() % 8 + rand() % 8;
		long r=0;
		int x;
		for (x = 0; x < 32; x++)
		{
			int t = 0;;
			char data;
			t = rand() % 8;		//보통
			data = t + '0';

//			fn_rand_length();	//느림
//			t = rand_data[x]-'0';
//			data = rand_data[x];

			fwrite(&data, 1, 1, fp3);

			if (t == 0) t = 2;
			r += t*x;
		}
		cnt++;

		l = l - r;

//		if (r < l)	l = l - r;
		//	l = l + rand()%8+rand()%8;
		//	printf("%d\n", l);

//		TRACE("[] %ld %ld \n", l, r);

		//중복된값.
		char m = *(mem + l + 100000);
		if (m == '0')
		{
			TRACE("중복된값\n");
			continue;
		}

		*(mem+l+1000000) = '0';
	}

	int i;
	for (i = 0; i < 10000000; i++)
	{
		char data = *(mem+i);
		fwrite(&data, 1, 1, fp);
	}
	delete mem;

	printf("\n");
	fclose(fpr);
	fclose(fp);
	fclose(fp2);
	fclose(fp3);

	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test.7z test.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test2.7z test2.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test3.7z test3.txt");

}


#include <deque>

using namespace std;

void CtestDlg::OnBnClickedButton4()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.

	deque<long> dq;

	FILE* fpr;
	fpr = fopen("test.bmp", "rb");
	FILE* fp;
	fp = fopen("test.txt", "wt");
	FILE* fp2;
	fp2 = fopen("test2.txt", "wb");
	FILE* fp3;
	fp3 = fopen("test3.txt", "wb");

	char* mem;
	mem = (char*)malloc(10000000);
	memset(mem, 0x00, 10000000);

	srand(time(NULL));
	char buf[100] = { "22" };
	long cnt = 0;
	long tmp = 0;
	while (1)
	{
		unsigned char data;
		int e;
		int i;
		for (i = 0; i < 6; i++)
		{
			e = fread(&data, 1, 1, fpr);
			buf[i] = data;
		}
		if (e == 0) break;
		int len = strlen(buf);

		long l = atol(buf);
		/*
				if (l == 0)
				{
					data = l;
		//			fwrite(&data, 1, 1, fp3);
					continue;
				}
				else
				{
					data = ' ';
		//			fwrite(&data, 1, 1, fp3);
				}
		*/
		int r = pow(rand() % 8 * rand() % 8 * rand() % 8, 2) + rand() % 8;
		if (r < l)	l = l - r;
		//	l = l + rand()%8+rand()%8;
		//	printf("%d\n", l);

		if (l < tmp)
		{
			dq.push_front(cnt);
		}
		else
		{
			dq.push_back(cnt);
		}
		cnt++;

		tmp = l;

		*(mem + l + 1000000) = '0';
	}

	int i;
	for (i = 0; i < 10000000; i++)
	{
		char data = mem[i];
		fwrite(&data, 1, 1, fp);
	}
	for (i = 0; i < dq.size(); i++)
	{
		long l = dq[i];
		sprintf(&buf[0], "%d", l);
//		fwrite(&data, 1, 1, fp2);

		int k;
		for (k = 0; k < 6; k++)
		{
			char data = buf[k];
			fwrite(&data, 1, 1, fp2);
		}
		char data = ' ';
		fwrite(&data, 1, 1, fp2);
	}
	delete mem;

	printf("\n");
	fclose(fpr);
	fclose(fp);
	fclose(fp2);
	fclose(fp3);

	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test.7z test.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test2.7z test2.txt");
	system("\"C:\\Program Files\\7-Zip\\7z.exe\" a test3.7z test3.txt");



}
